#! /usr/bin/env python3
# -*- coding: utf-8 -*-
__version__='202110281605/33'
"""
Program wczytuje pliki z hpc015, sumuje godziny i wstawia do słowników godzina/odwiedziny
W przyszłości powinny surowe dane z hpc iść do tablicy minutowej bazy danych,
a dopiero tablica minutowa powinna być przekształcana na godzinową,
aby weryfikować, czy dana minuta jest zliczona,czy nie.
Na razie jest jak jest, bo jest mało danych.

202110281232/33 działa z małymi literami w bazie danych dla pendrive. Z aplikacją nie testowano.
202110281212/33 jest niepotrzebny sys.exit()
*-32 początek małych liter
*-27
funkcja szukająca liczników
wynik - słownik nazwa licznika, wykaz plików ze ścieżkami
 os.path.splitext(path)

    Split the pathname path into a pair (root, ext) such that root + ext == path
*-25
$ ls -1 Export
4E46CE2F_20210826.csv
D3E5E833_20210830.csv
D3E5E833_20210831.csv
D3E5E833_20210901.csv

wersja do aplikacji pojedynczy katalog rootPath ze wszystkimi plikami
*-24
Wersja z grafbarem
*-23
wydaje się, że działa po wyszyszczeniu tablic.
*-22
wstawianie kawałków wersji -18
*-21
 - zjada pierwszą i ostatnią minutę. 20210809
*-19
odrzucenie starych, przetworzonych plików
*-14
*-13
kolejna wersja
*-12
nowe dbg
*-11
lastCSV()
20210811/11
a.Zablokowanie otwierania obrobionych plików przez znajdowanie
maksymalnej daty w bazie. trzeba odnaleźć najnowszą tabelę i najnowszą w niej datę.
b. wyszukiwanie właściwego katalogu DATALIST
202108101600/09
edytuje tablice
'202108101519/08'
funkcja createTables(), dbg()
202108101044/07
poprawiona analiza danych z licznika - dodawanie do ostatniego rekordu pliku.
202108091032/04
tworzy prawidłowe tablice bez danych wtępnych.
"""


import os
#https://docs.sqlalchemy.org/en/14/tutorial/dbapi_transactions.html
import sys
import time
from sqlalchemy import create_engine
from sqlalchemy import text
import calendar
from hpc2lvconf import rootPath, host, user, dbbase, psw, debug

dirType = 1 # dane na pendrive
# dirType = 2 # dane z aplikacji
if len(sys.argv) > 1:
    debug = int(sys.argv[1])

def dbg(data,n=1):
    #Pokazuje dane dla n<debug
    # duże n = 0 pokazywane zawsze
    if debug > n:
        for x in data:
            print(x)

def cls():
    if(debug == 0):
        os.system('cls' if os.name=='nt' else 'clear')
def tableDate(name):
   #
   year = int(name[-6:-2])
   month = int(name[-2:])
   return (year,month)
def lmd(name):
   return calendar.monthrange(int(name[-6:-2]),int(name[-2:]))[1]



engine = create_engine\
("mariadb+mariadbconnector://%s:%s@%s:3306/%s" % \
 (user,psw,host,dbbase), echo=False, future=True)


# skrypt obróbki plików z hpc015
#monthTables = {}

def hdatetime(stri):
    stri=stri.replace('-','')
    stri=stri.replace(' ','')
    stri=stri.replace(':','')
    return stri[0:10]

def tablehour(stri1):
    dl = 1
    dbg(("tablehour(%s)" % (stri1,),),dl)
    stri = hdatetime(stri1)
    if stri.isdecimal():
        
        
        
        dbg(("tablehour(%s)" % stri,),dl)
        if stri1.find("00:00") > -1:
            out = "%04d00" % int(stri[6:])
        else:
            out = "%04d00" % (int(stri[6:])+1)
    else:
        out = False
    dbg(("tablehour(%s) =  %s" % (stri, out),),dl)
    return out


monthTables = {}
#def cfiles(counterPath,lasts):
def cfiles(counterName,lasts):    
    """
Wykonywane dla określonego licznika
stare
pathList
['DATALIST/E4FD6983', 'DATALIST/DA67D35D']
lasts
{
'c4E46CE2Fi': '20210827.CSV',
'c4E46CE2Fo': '20210827.CSV',
'cDA67D35Di': '20210826.CSV',
'cDA67D35Do': '20210826.CSV',
'cE4FD6983i': '20210826.CSV',
'cE4FD6983o': '20210826.CSV'
}
nowe
---counterDic:
--- E4FD6983
[
('210804', 'DATALIST/E4FD6983/202108/20210804.CSV'),
('210806', 'DATALIST/E4FD6983/202108/20210806.CSV'),
('210805','DATALIST/E4FD6983/202108/20210805.CSV'),
('210802','DATALIST/E4FD6983/202108/20210802.CSV'),
('210811','DATALIST/E4FD6983/202108/20210811.CSV'),
('210809', 'DATALIST/E4FD6983/202108/20210809.CSV'),
('210803', 'DATALIST/E4FD6983/202108/20210803.CSV'),
('210810', 'DATALIST/E4FD6983/202108/20210810.CSV'),
('210728', 'DATALIST/E4FD6983/202107/20210728.CSV'),
('210729', 'DATALIST/E4FD6983/202107/20210729.CSV'), ('210730', 'DATALIST/E4FD6983/202107/20210730.CSV')]
--- DA67D35D
[
('210804', 'DATALIST/DA67D35D/202108/20210804.CSV'),
('210806', 'DATALIST/DA67D35D/202108/20210806.CSV'),
('210805', 'DATALIST/DA67D35D/202108/20210805.CSV'),
('210802', 'DATALIST/DA67D35D/202108/20210802.CSV'),
('210811', 'DATALIST/DA67D35D/202108/20210811.CSV'),
('210809', 'DATALIST/DA67D35D/202108/20210809.CSV'),
('210803', 'DATALIST/DA67D35D/202108/20210803.CSV'),
('210810', 'DATALIST/DA67D35D/202108/20210810.CSV')]

-------lasts
{
'c4E46CE2Fi': ('4E46CE2F', '20210827'),
'c4E46CE2Fo': ('4E46CE2F', '20210827'),
'cDA67D35Di': ('DA67D35D', '20210826'),
'cDA67D35Do': ('DA67D35D', '20210826'),
'cE4FD6983i': ('E4FD6983', '20210826'),
'cE4FD6983o': ('E4FD6983', '20210826')}


"""
    dl = 2

    #print('*' * 50)
    #dbg(('counterPath =', counterPath),dl)
    #counterName = os.path.basename(counterPath)
    dbg(("counterName", counterName),dl)
    iName = "c%si" % counterName
    if iName in lasts.keys():
        ilastFile = lasts[iName][1]#'c4E46CE2Fi': ('4E46CE2F', '20210827'),
    else:
        ilastFile = '!'
    dbg(("ilastFile",ilastFile),dl)
    oName = "c%so" % counterName
    if oName in lasts.keys():
        olastFile = lasts[oName][1]#c4E46CE2Fo': ('4E46CE2F', '20210827')
    else:
        olastFile = '!'
    dbg(("olastFile", olastFile),dl)
    lastFile = ilastFile
    if olastFile < ilastFile:
        lastFile = olastFile
    lastFile6 = lastFile[2:]
    """    
    filePathList = []
    for root, dirs, files in os.walk(counterPath):
        if len(files) > 0:
            for file in files:
                filePath = os.path.join(root,file)
                #print('file =',filePath)
                filePathList.append(filePath)

    filePathList.sort()
    dbg(("filePathList = ",filePathList),dl)"""
    fileDates = []#daty plików
    for data in counterDic[counterName]:
        fileDates.append(data)
    fileDates.sort()
    dbg(("--fileDates",),dl)
    dbg(fileDates,dl)
    dbg(("lastFile = "+ lastFile6,),dl)
    
    
    for date in fileDates:
        #if os.path.basename(path) < lastFile:
        if date[0]< lastFile6:
            
            continue
        dbg(("fileDate",date),dl)#ścieżka do konkretnego pliku z licznika
        
        #czy dodawać do tablicy?
        iok = True
        ook = True
        if date[0] < ilastFile[2:]:
            iok = False
        if date[0] < olastFile[2:]:
            ook = False
        dbg(("iok", iok,"  ook",ook),dl)
        inn = 0
        out = 0
        fs=open(date[1],'r')
        stri=fs.read()
        fs.close()
        dbg(("fileContent: " + stri,),dl)
        #print(stri)
        #print("nowalinia")
        if stri.find('\r') > -1:
            #print( "nowa linia \\r")
            rows = stri.split('\r')
        else:
            if stri.find("\n") > -1:
                #print( "nowa linia \\n")
                rows = stri.split('\n')
        if debug > dl:
            print("***Rows**")
            for row in rows:
                print(row)
            print("END")
        intable = "c%si_%s" % (counterName,hdatetime(rows[1].split(',')[0])[0:6])

        outtable = "c%so_%s" % (counterName,hdatetime(rows[1].split(',')[0])[0:6])

        #print("nazwa licznika =" , counterName, intable,outtable)
        if not intable in monthTables.keys():
            monthTables[intable] = {}
        if not outtable in monthTables.keys():
            monthTables[outtable] = {}
        ohour = '0' # stara godzina
        nrows= len(rows)
        dbg(("ilość rekordów =", nrows),dl)
        nrow = 1 # linia nagłówków "000001 datetime,In,Out"
        for row in rows:
            nrow +=1
            dbg(("nr: %06d %s" % (nrow,row),),dl)
            row = row.split(',')
            if row[0].find('datetime')>-1:
                continue
            hour=tablehour(row[0])
            dbg(("hour: %s" % hour,),dl)
            if hour:
                if hour != ohour: #nowa godzina
                    if str.isdecimal(ohour):
                        dbg(("nowa godzina:",row[0],row[1],row[2]),dl)
                        if iok:

                                
                            monthTables[intable][hour] = int(row[1])
                        if ook:
                            
                            monthTables[outtable][hour] = int(row[2])

                        
                        
                        ohour = hour
                else:
                    if iok:
                        monthTables[intable][hour] += int(row[1])
                    if ook:
                        monthTables[outtable][hour] += int(row[2])
        #koniec pliku a nie ma nowej godziny

             

        dbg(("intable %s" % intable,monthTables[intable],),dl)
        dbg(("outtable %s" % outtable,monthTables[outtable],),dl)
                
                #print(row,tablehour(row[0]),inn,out)
        #print("-#-#-#   monthTables: ",monthTables)
    return monthTables

def counterFiles(rootPath):
    #os.path.abspath(path)
    global dirType
    dl = 2
    dbg(["rootPath:"+rootPath,],dl)
    counterDic = {}
    #wyszukiwanie ścieżek z danymi liczników
    for root, dirs, files in os.walk(rootPath):
        #dbg((root,),dl)
        #print( 'root =', root)
        #print( 'dirs =', dirs)
        #print( 'files =', files)
           
        for file in files:
            dbg(("filename  " + file,),dl)
            if file.find(".csv") > -1:
                dirType = 2 #aplikacja
                counter = file[:8].lower()
                dbg(('counterName = ' + counter,dl))
                if counter not in counterList:
                    counterList.append(counter)
                    dbg(("####licznik %s dodany 2" % counter,),dl)
                    counterDic[counter]=[]
                counterDic[counter].append((file[-10:-4],os.path.join(root,file)))
            if file.find(".CSV") > -1:
                dirType = 1 #pendrive
                counter1 = os.path.dirname(root)
                #print('counter', counter1)
                counter = os.path.basename(counter1).lower()#0955

                if counter not in counterList:
                    counterList.append(counter)
                    counterDic[counter]=[]                    
                    dbg(("****licznik %s dodany 1" % counter,),dl)
                    counterDic[counter]=[]
                counterDic[counter].append((file[-10:-4],os.path.join(root,file)))                        
                        
    dbg(("---counterDic:",),dl)
    #print(counterDic)
    if debug > dl:
        for key in counterDic.keys():
            print("---",key, counterDic[key])
    return counterDic
    
    dl = 2
    dbg(["rootPath:",rootPath],dl)
    #wyszukiwanie ścieżek z danymi liczników
    for root, dirs, files in os.walk(rootPath):
        #dbg((root,),dl)
        print( 'root =', root)
        print( 'dirs =', dirs)
        print( 'files =', files)
        if len(files) > 0:
            if files[0].find(".CSV") > -1:
               
           
                counter1 = os.path.dirname(root)
                print('counter', counter1)
                counter = os.path.basename(counter1)
                print('counter1', counter)
                if counter not in counterList:
                    counterList.append(counter)
                    pathList.append(counter1)
            else:
                if files[0].find(".csv") > -1:
                    dirType = 2 #aplikacja
                    pathList.append(root)
                
    dbg((pathList,),dl)
    return #pathList 
def listTables(conn):
    dl = 2
    #wykaz tabel w bazie

    tableList = []
    dbg(("tableList ",tableList),dl)   
    #sprawdzanie jakie są tablice
    result = conn.execute(text("show tables"))
    for r in result:
        
        
        if r[0]:
            name = r [0]
            if name != 'regions':
                tableList.append(name)
    dbg(("Lista tablic w bazie 2026:",tableList,'koniec'),dl)
    return tableList
def lastTables(conn,lista):
    dl = 2
    #lista tablic z ostatniego miesiąca
    #na lista są tablice różnych liczników z różnych mieisęcy
    dicti = {}
    for table in lista:
        name = table[:-7]
        dbg((name,),dl)
        if name in dicti.keys():
            if dicti[name] < table:
                dicti[name] = table
        else:
            dicti[name] = table
    dbg((dicti,),dl)
    return dicti
def lastCSV(conn,name):
    dl =2
    #ostatni plik z niezerowymi danymi do tablicy name
    result = conn.execute(text("select time,count from %s" % name))
    lasth = ''
    for row in result:
        dbg((row,),dl)
        if row[1]>0:
            lasth = row[0]#ostatnia niezerowa godzina
    dbg(("name =",name,"lasth =", lasth),2)
    """
name =
cDA67D35Di_202108
lasth =
261700

"""

    csv = (name[1:9],name[-6:]+lasth[:2])
    dbg((csv,),dl)
    return csv
    
def lastCSVs(conn,lista):
    #tworzy słownik dla ostatnich plików dla tablic.
    """
-------lasts
{
'c4E46CE2Fi': ('4E46CE2F', '20210827'),
'c4E46CE2Fo': ('4E46CE2F', '20210827'),
'cDA67D35Di': ('DA67D35D', '20210826'),
'cDA67D35Do': ('DA67D35D', '20210826'),
'cE4FD6983i': ('E4FD6983', '20210826'),
'cE4FD6983o': ('E4FD6983', '20210826')
}
"""

    l={}
    dl = 2
    dbg(("----lastCSV--------",),dl)
    dbg(lista,dl)
    dbg(("----koniec lista--------",),dl)
    for name in lista.keys():
        l[name] = lastCSV(conn, lista[name])
    dbg((l,),dl)
    return l
    
    

def createTables(conn):
    dl = 2
    tableList = []
    dbg(("tableList ",tableList),dl)   
    #sprawdzanie jakie są tablice
    result = conn.execute(text("show tables"))
    for r in result:
        if r:
            #print('klucze: ',r.keys())
            tableList.append(r['Tables_in_%s' % dbbase])
    dbg(("Lista tablic w bazie 2027:",tableList,'koniec'), dl)
    #sys.exit('2021')


    for key in monthTables.keys():
        dbg(("key2030 %s" % key,), dl)

        #if not key in tableList:
        if not key in tableList:
            dbg(("------------nie istnieje tablica %s tworzę" % key,),dl)
            #sys.exit('2028')
            
            #with engine.begin() as conn:
                #conn.execute(text("CREATE TABLE :n (x int, y int)"),[{"n": key}])
            conn.execute(text("CREATE TABLE %s \
(time char(6) not null primary key , \
count int(6), \
ec tinyint(4),\
ep tinyint(4),\
es tinyint(4), \
state char(1))" % key))
                
        else:
            dbg(('Tablica istnieje',),dl)
# sprawdzanie ilości wierszy
        result = conn.execute(text("select count(*) from %s" % key))
        for d in result.mappings():
            rownumber =(d['count(*)'])
            expdrownumber = lmd(key)*24
            if rownumber < expdrownumber:
                dbg(( "!!!!!!!!!!!!!!  brakuje lub nie ma wierszy",),dl)
                if rownumber >0:
                    dbg(("################W tablicy są jakieś wiersze, ale za mało",),dl)
                    conn.execute(text("delete from %s" % key))
                    dbg(("$$$$$$$$$$$$$$$$$$   tablica wyczyszczona",),dl)
                # generowanie listy słowników
                
                rowList = []
                for day in range(lmd(key)):
                    for hour in range(24):
                        rowList.append({"time":'%02d%02d00' %(day+1, hour+1),\
                                        "count":0, "ec":0, "ep":0, "es":0, "state":'n'})
                        #print(rowList[-1:])
                conn.execute(text("insert into %s values \
(:time, :count, :ec, :ep, :es, :state)" % key),rowList)
                dbg(("tablica  %s wypełniona" % key,),dl)

            else:
                dbg(("Tablica ma wszystkie wiersze",),dl)
                
def editTables(conn,tables,number):
    dl = 2
    dbg(("----funkcja editTables()",),dl)
    for table in tables.keys():
        #table - nazwa tablicy
        dbg((table,),dl)#nazwa tablicy
        for key in tables[table]:
            #key datagodzina
            count = tables[table][key]
            #time = tablehour(key)
            time = key
            dbg((time,count),dl)

            result = conn.execute(
            text("UPDATE %s SET count=:y, es=:z WHERE time=:x" % table),
            [{"x": time, "y":count, "z":0}]
            )
            number -=1
            cls()
            #print("%3d rekordów pozostało do wyłania." % number)
            print("*" * number)
            
   

################################   start   ##########################
print('Start0, wersja =',__version__)
#debug = 3 #im większse to wiecej pokazuje
counterList=[]
pathList=[]
dl = 2
#debug = 0
# dirType = 1 # dane na pendrive
# dirType = 2 # dane z aplikacji
counterDic = counterFiles(rootPath)
dbg(("counterDic2034:", str(counterDic)),dl)
#sys.exit("starczy 2036")
#Najpierw wyszukujemy ściżki do danych liczników

dbg(("dirType = %d" % dirType,),dl)

#następnie wyszukujemy tablice w bazie
#i dla każdej ostatniej dla licznika ostatni dzień
#print(counterList)
#print(pathList)
"""
for path in pathList:
    cfiles(path)
#print(monthTables)
for key in monthTables.keys():
    print(key)
    for key1 in monthTables[key].keys():
        print(tablehour(key1),monthTables[key][key1])"""
cls()
print('Start, wersja =',__version__)
#tableList = []
#print("tableList ",tableList)
#dictii = {}
with engine.begin() as conn:
    lista = listTables(conn)#lista tablic w bazie
    dbg(("lista",lista),dl)
    last = lastTables(conn, lista)
    dbg(("--lastTables", last),dl)
    lasts = lastCSVs (conn,last)
    """
lasts
{'c4E46CE2Fi': '20210827.CSV','c4E46CE2Fo': '20210827.CSV',
'cDA67D35Di': '20210826.CSV', 'cDA67D35Do': '20210826.CSV',
'cE4FD6983i': '20210826.CSV', 'cE4FD6983o': '20210826.CSV'}

"""
    dbg(("-------lasts",lasts),dl)
    #sys.exit("starczy")
    #dbg(("----pathList",),dl)
    #dbg((pathList),dl)

    for counter in counterDic.keys():
        cfiles(counter, lasts)
    #sys.exit("starczy1")           
    createTables(conn)
    dbg(("------------ monthTables",),dl)
    records = 0
    for table in monthTables.keys():
        dbg((table,),dl)
        for key in monthTables[table].keys():
            records += 1
            dbg(("%s: %s" % (key,monthTables[table][key]),),dl)
    cls()
    print("*" * records )
    
 
    editTables(conn,monthTables,records)
    print("Gotowe")
    time.sleep(3)
